import { Tesseract } from 'tesseract.ts';
import { Injectable, NgModule, Component, EventEmitter, Input, Output, KeyValueDiffers, HostListener, ElementRef, Renderer2, ViewEncapsulation, defineInjectable } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule } from '@angular/forms';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/customannotation.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class CustomannotationService {
    constructor() { }
}
CustomannotationService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
CustomannotationService.ctorParameters = () => [];
/** @nocollapse */ CustomannotationService.ngInjectableDef = defineInjectable({ factory: function CustomannotationService_Factory() { return new CustomannotationService(); }, token: CustomannotationService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * Generated from: lib/customannotation.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
let PDFJSAnnotate = require('../assets/JS/pdf-annotate.js');
const { UI } = PDFJSAnnotate;
class CustomannotationComponent {
    /* params declaration end */
    /**
     * @param {?} differs
     * @param {?} _elementRef
     * @param {?} _renderer
     */
    constructor(differs, _elementRef, _renderer) {
        this.differs = differs;
        this._elementRef = _elementRef;
        this._renderer = _renderer;
        this.pageChanged = new EventEmitter();
        this.annotationEdited = new EventEmitter();
        this.annotationAdded = new EventEmitter();
        this.annotationDeleted = new EventEmitter();
        this.captureData = new EventEmitter();
        this.mouseLeaveFrmPDF = new EventEmitter();
        this.annotationPDFError = new EventEmitter();
        this.isPdfLoaded = new EventEmitter();
        this.documentId = "";
        this.loadingMsg = "----Loading PDF---";
        /* params declaration start */
        this.showLoading = false;
        this.isFirstLoad = false;
        this.renderCircleObj = [];
        this.PDFRenderOption = {
            documentId: this.documentId,
            pdfDocument: null,
            scale: 1,
            rotate: 0
        };
        this.PDFInfo = {
            totalPages: 1,
            currentPage: 1
        };
        this.pageLoaded = {};
        this.pageTmpCanvasLoaded = {};
        this.annotationHistory = {};
        this.editHistoryLength = "0";
        this.handleSaveEdit = (/**
         * @return {?}
         */
        function () {
            UI.disableEdit();
            this.resetActiveRectClass();
            this.mouseLeaveFrmPDF.emit();
        });
        this.handleDeleteAlert = (/**
         * @return {?}
         */
        function () {
            if (this.config.deleteAlert) {
                /** @type {?} */
                var annotationId = document.getElementById("pdf-annotate-edit-overlay").getAttribute("data-target-id");
                /** @type {?} */
                let nodes = Array.from(document.getElementById(this.config.viewerId).querySelectorAll(`[data-pdf-annotate-id="${annotationId}"]`));
                [...nodes].forEach((/**
                 * @param {?} n
                 * @return {?}
                 */
                (n) => {
                    n.parentNode.removeChild(n);
                }));
                PDFJSAnnotate.__storeAdapter.deleteAnnotation(this.documentId, annotationId);
            }
        });
        this._renderer.listen(_elementRef.nativeElement, 'mouseleave', (/**
         * @param {?} event
         * @return {?}
         */
        (event) => {
            UI.disableEdit();
            this.resetActiveRectClass();
            this.mouseLeaveFrmPDF.emit();
            //this.rectHideandShow("color");
            this.filterAnnotationsbyStatus(this.config.statusFilter);
            document.getElementById(this.config.viewerId).classList.remove('cropping');
            UI.disableRect(); // to disable the edit annotation
        }));
        this.handleAnnotationClick = this.handleAnnotationClick.bind(this);
        this.handleSaveEdit = this.handleSaveEdit.bind(this);
        this.handleDeleteAlert = this.handleDeleteAlert.bind(this);
        this.handleUndo = this.handleUndo.bind(this);
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        /*loading script dynamically */
        this.loadScript("./assets/JS/pdf.js");
        this.loadScript("./assets/JS/pdf_viewer.js");
        /* set default paramas */
        this.PDFRenderOption.documentId = this.documentId;
        this.PDFRenderOption.scale = this.config.zoomLevel || 1;
        this.PDFRenderOption.rotate = this.config.rotate || 0;
        this.config.history_enabled = this.config.history_enabled || false;
        this.config.history_count_per_annotation = this.config.history_count_per_annotation || 5;
        this.config.rendercirclesalongwithindex = this.config.rendercirclesalongwithindex || false;
        this.config.deleteAlert = this.config.deleteAlert || false;
        this.config.useteseract = this.config.useteseract || false;
        this.config.viewerId = this.config.viewerId || 'example-viewerid';
        /* changes detectio for zoom */
        this.configDiffer = this.differs.find(this.config).create();
        window.addEventListener("scroll", this.pdfScroll.bind(this));
        /** @type {?} */
        var that = this;
        /*adapter to save data */
        /** @type {?} */
        let MyStoreAdapter = new PDFJSAnnotate.StoreAdapter({
            /**
             * @param {?} documentId
             * @param {?} pageNumber
             * @return {?}
             */
            getAnnotations(documentId, pageNumber) {
                return new Promise((/**
                 * @param {?} resolve
                 * @param {?} reject
                 * @return {?}
                 */
                (resolve, reject) => {
                    /** @type {?} */
                    var annotations = that.getAnnotations(documentId).filter((/**
                     * @param {?} i
                     * @return {?}
                     */
                    i => {
                        return i.page === pageNumber && i.class === 'Annotation';
                    }));
                    resolve({
                        documentId,
                        pageNumber,
                        annotations
                    });
                }));
            },
            /**
             * @param {?} documentId
             * @param {?} annotationId
             * @return {?}
             */
            getAnnotation(documentId, annotationId) {
                //return Promise.resolve(annotation);
                //return Promise.resolve(annotation);
                /** @type {?} */
                var annotation;
                for (var i = 0, l = that.PDFannotations.length; i < l; i++) {
                    if (that.PDFannotations[i].uuid === annotationId) {
                        annotation = that.PDFannotations[i];
                        break;
                    }
                }
                return Promise.resolve(annotation);
                //return Promise.resolve(that.getAnnotations(documentId)[that.findAnnotation(documentId, annotationId)]);
            },
            /**
             * @param {?} documentId
             * @param {?} pageNumber
             * @param {?} annotation
             * @return {?}
             */
            addAnnotation(documentId, pageNumber, annotation) {
                return new Promise((/**
                 * @param {?} resolve
                 * @param {?} reject
                 * @return {?}
                 */
                (resolve, reject) => {
                    annotation.class = 'Annotation';
                    if (that.newannotationuuid != "" && that.newannotationuuid != undefined) {
                        annotation.uuid = that.newannotationuuid;
                    }
                    else if (annotation.uuid == "") {
                        annotation.uuid =
                            'UUId' +
                                Math.random()
                                    .toFixed(2)
                                    .toString();
                    }
                    annotation.page = pageNumber; //that.PDFInfo.currentPage;
                    //that.PDFInfo.currentPage;
                    /** @type {?} */
                    let annotations = that.getAnnotations(documentId);
                    annotations.push(annotation);
                    document.getElementById(that.config.viewerId).classList.remove('cropping');
                    that.updateAnnotations(documentId, annotations);
                    resolve(annotation);
                    /*teserract code start */
                    if (that.config.useteseract) {
                        /** @type {?} */
                        var canvas = (/** @type {?} */ (document.getElementById("tmpcanvas" + that.config.viewerId + pageNumber)));
                        /** @type {?} */
                        let ctx = canvas.getContext('2d');
                        /** @type {?} */
                        const zoom = 3;
                        /** @type {?} */
                        let imageData = ctx.getImageData(annotation.x * zoom, annotation.y * zoom, annotation.width * zoom, annotation.height * zoom);
                        Tesseract.recognize(imageData)
                            .then((/**
                         * @param {?} result
                         * @return {?}
                         */
                        function (result) {
                            that.captureData.emit({ "annotation": annotation, "text": result.text });
                            //console.log(result.text)
                        }));
                    }
                    /* teseract code end */
                    that.annotationAdded.emit(annotation);
                    that.rectHideandShow('open');
                    that.newannotationuuid = "";
                    UI.disableRect(); // to disable the edit annotation
                }));
            },
            /**
             * @param {?} documentId
             * @param {?} annotationId
             * @param {?} annotation
             * @return {?}
             */
            editAnnotation(documentId, annotationId, annotation) {
                return new Promise((/**
                 * @param {?} resolve
                 * @param {?} reject
                 * @return {?}
                 */
                function (resolve, reject) {
                    /** @type {?} */
                    var annotations = that.getAnnotations(documentId);
                    annotations[that.findAnnotation(documentId, annotationId)] = annotation;
                    that.updateAnnotations(documentId, annotations);
                    that.annotationEdited.emit(annotation);
                    resolve(annotation);
                    setTimeout((/**
                     * @return {?}
                     */
                    () => {
                        that.editAnnotationEvent(annotation.uuid);
                    }), 100);
                    // setTimeout(() => {
                    //   UI.disableEdit();
                    // }, 10000);
                    /*teserract code start */
                    if (that.config.useteseract) {
                        /** @type {?} */
                        var canvas = (/** @type {?} */ (document.getElementById("tmpcanvas" + that.config.viewerId + annotation.page)));
                        /** @type {?} */
                        let ctx = canvas.getContext('2d');
                        /** @type {?} */
                        const zoom = 3;
                        /** @type {?} */
                        let imageData = ctx.getImageData(annotation.x * zoom, annotation.y * zoom, annotation.width * zoom, annotation.height * zoom);
                        Tesseract.recognize(imageData)
                            .then((/**
                         * @param {?} result
                         * @return {?}
                         */
                        function (result) {
                            that.captureData.emit({ "annotation": annotation, "text": result.text });
                            //console.log(result.text)
                        }));
                    }
                    /* teseract code end */
                }));
            },
            deleteAnnotation: (/**
             * @param {?} documentId
             * @param {?} annotationId
             * @return {?}
             */
            function deleteAnnotation(documentId, annotationId) {
                return new Promise((/**
                 * @param {?} resolve
                 * @param {?} reject
                 * @return {?}
                 */
                function (resolve, reject) {
                    /** @type {?} */
                    var index = that.findAnnotation(documentId, annotationId);
                    if (index > -1) {
                        /** @type {?} */
                        var annotations = that.getAnnotations(documentId);
                        annotations.splice(index, 1);
                        that.updateAnnotations(documentId, annotations);
                        that.annotationDeleted.emit(annotationId);
                    }
                    resolve(true);
                }));
            }),
            /**
             * @param {?} documentId
             * @param {?} annotationId
             * @return {?}
             */
            getComments(documentId, annotationId) {
                return new Promise((/**
                 * @param {?} resolve
                 * @param {?} reject
                 * @return {?}
                 */
                (resolve, reject) => { }));
            },
            /**
             * @param {?} documentId
             * @param {?} annotationId
             * @param {?} content
             * @return {?}
             */
            addComment(documentId, annotationId, content) { },
            /**
             * @param {?} documentId
             * @param {?} commentId
             * @return {?}
             */
            deleteComment(documentId, commentId) { }
        });
        PDFJSAnnotate.setStoreAdapter(MyStoreAdapter);
        this.showLoading = true;
        this.isFirstLoad = true;
        setTimeout((/**
         * @return {?}
         */
        () => {
            this.renderPdf();
        }), 0);
        /* create dynamic HTML tag for save function when edit annotation happend */
        /** @type {?} */
        let child_div = this._renderer.createElement('div');
        child_div.setAttribute('id', 'pdf-annotate-edit-overlay-done');
        child_div.classList.add('crud-annotation');
        /* popover div */
        /** @type {?} */
        let popoverdiv = this._renderer.createElement('div');
        popoverdiv.classList.add("popover");
        /* popover-arrow div */
        /** @type {?} */
        let popoverarrowdiv = this._renderer.createElement('div');
        popoverarrowdiv.classList.add("popover-arrow");
        /** @type {?} */
        let right_icon_created = this._renderer.createElement('i');
        right_icon_created.innerHTML = "<span> Disable Edit </span>";
        (/** @type {?} */ (right_icon_created.classList.add("fa")));
        (/** @type {?} */ (right_icon_created.classList.add("fa-check-circle")));
        right_icon_created.addEventListener('click', this.handleSaveEdit);
        this._renderer.appendChild(popoverdiv, popoverarrowdiv);
        this._renderer.appendChild(popoverarrowdiv, right_icon_created);
        /*delete confirmation div created */
        /** @type {?} */
        let delete_child_div = this._renderer.createElement('div');
        delete_child_div.innerHTML = "<span> Delete </span>";
        delete_child_div.setAttribute('id', 'annotate-delete-overlay-done');
        delete_child_div.classList.add('crud-delete-annotation');
        delete_child_div.classList.add('disableDelete');
        delete_child_div.addEventListener('click', this.handleDeleteAlert);
        this._renderer.appendChild(child_div, delete_child_div);
        if (this.config.history_enabled) {
            /** @type {?} */
            let undo_icon_created = this._renderer.createElement('i');
            undo_icon_created.innerHTML = "<span id='undo_span_id'> Undo </span>";
            (/** @type {?} */ (undo_icon_created.classList.add("fa")));
            (/** @type {?} */ (undo_icon_created.classList.add("fa-undo")));
            undo_icon_created.addEventListener('click', this.handleUndo);
            this._renderer.appendChild(popoverarrowdiv, undo_icon_created);
        }
        this._renderer.appendChild(child_div, popoverdiv);
        this.child_div = child_div;
        UI.addEventListener('annotation:click', this.handleAnnotationClick);
    }
    /* load pdf's on scroll  */
    /**
     * @param {?} event
     * @return {?}
     */
    pdfScroll(event) {
        if (this.scrollFromJS === true) {
            this.scrollFromJS = false;
            return;
        }
        if (document.getElementById(this.config.viewerId) === null)
            return;
        /** @type {?} */
        let visiblePageNum = Math.round(event.target.scrollTop / this.PAGE_HEIGHT) + 1;
        this.pageChanged.emit(visiblePageNum.toString());
        if (visiblePageNum <= this.PDFInfo.totalPages) {
            this.PDFInfo.currentPage = visiblePageNum;
            if (this.config.loadallpages === false) {
                /** @type {?} */
                var visiblePage = document.getElementById(this.config.viewerId).querySelector('.page[data-page-number="' + visiblePageNum + '"][data-loaded="false"]');
                if (visiblePage && this.pageLoaded[visiblePageNum] == undefined) {
                    this.pageLoaded[visiblePageNum] = true;
                    setTimeout((/**
                     * @return {?}
                     */
                    function () {
                        this.renderPage(visiblePageNum);
                        this.showBeforePreviousPagesonScroll(visiblePageNum);
                        if (this.newannotationuuid) {
                            this.rectHideandShow('transparent');
                        }
                        this.filterAnnotationsbyStatus(this.config.statusFilter);
                    }).bind(this), 0);
                }
                else {
                    this.showBeforePreviousPagesonScroll(visiblePageNum);
                    this.pageLoaded[visiblePageNum] = true;
                    this.filterAnnotationsbyStatus(this.config.statusFilter);
                }
            }
        }
        else {
            this.PDFInfo.currentPage = this.PDFInfo.totalPages;
            this.filterAnnotationsbyStatus(this.config.statusFilter);
        }
        // setTimeout(function() {
        // this.filterAnnotationsbyStatus(this.config.statusFilter);
        // }.bind(this), 1000);
    }
    /* function to load previous,before pages when setScroll function call */
    /**
     * @param {?} pageNumber
     * @return {?}
     */
    showBeforePreviousPagesonScroll(pageNumber) {
        if (pageNumber != 1 && pageNumber != this.PDFInfo.totalPages) {
            /** @type {?} */
            let previouspage = document.getElementById(this.config.viewerId).querySelector(`.page[data-page-number="${pageNumber - 1}"][data-loaded="false"]`);
            /** @type {?} */
            let nextpage = document.getElementById(this.config.viewerId).querySelector(`.page[data-page-number="${pageNumber + 1}"][data-loaded="false"]`);
            if (previouspage && nextpage && this.pageLoaded[pageNumber - 1] === undefined && this.pageLoaded[pageNumber + 1] === undefined) {
                this.pageLoaded[pageNumber - 1] = true;
                UI.renderPage(pageNumber - 1, this.PDFRenderOption).then((/**
                 * @param {?} __0
                 * @return {?}
                 */
                ([pdfPage, annotations]) => {
                    this.pageLoaded[pageNumber + 1] = true;
                    UI.renderPage(pageNumber + 1, this.PDFRenderOption).then((/**
                     * @param {?} __0
                     * @return {?}
                     */
                    ([pdfPage, annotations]) => {
                        if (this.config.useteseract)
                            this.teseRactInitforPage(pdfPage, pageNumber + 1);
                    }));
                }));
            }
            if (!previouspage && nextpage && this.pageLoaded[pageNumber + 1] === undefined) {
                this.pageLoaded[pageNumber + 1] = true;
                UI.renderPage(pageNumber + 1, this.PDFRenderOption).then((/**
                 * @param {?} __0
                 * @return {?}
                 */
                ([pdfPage, annotations]) => {
                    if (this.config.useteseract)
                        this.teseRactInitforPage(pdfPage, pageNumber + 1);
                }));
            }
            if (previouspage && !nextpage && this.pageLoaded[pageNumber - 1] === undefined) {
                this.pageLoaded[pageNumber - 1] = true;
                UI.renderPage(pageNumber - 1, this.PDFRenderOption).then((/**
                 * @param {?} __0
                 * @return {?}
                 */
                ([pdfPage, annotations]) => {
                    if (this.config.useteseract)
                        this.teseRactInitforPage(pdfPage, pageNumber - 1);
                }));
            }
        }
        if (pageNumber == 1) {
            /** @type {?} */
            let visiblePage = document.getElementById(this.config.viewerId).querySelector(`.page[data-page-number="${pageNumber + 1}"][data-loaded="false"]`);
            if (visiblePage && this.pageLoaded[pageNumber + 1] === undefined) {
                this.pageLoaded[pageNumber + 1] = true;
                UI.renderPage(pageNumber + 1, this.PDFRenderOption).then((/**
                 * @param {?} __0
                 * @return {?}
                 */
                ([pdfPage, annotations]) => {
                    if (this.config.useteseract)
                        this.teseRactInitforPage(pdfPage, pageNumber + 1);
                }));
            }
        }
        if (pageNumber === this.PDFInfo.totalPages) {
            /** @type {?} */
            let visiblePage = document.getElementById(this.config.viewerId).querySelector(`.page[data-page-number="${pageNumber - 1}"][data-loaded="false"]`);
            if (visiblePage && this.pageLoaded[pageNumber - 1] === undefined) {
                this.pageLoaded[pageNumber - 1] = true;
                UI.renderPage(pageNumber - 1, this.PDFRenderOption).then((/**
                 * @param {?} __0
                 * @return {?}
                 */
                ([pdfPage, annotations]) => {
                    if (this.config.useteseract)
                        this.teseRactInitforPage(pdfPage, pageNumber - 1);
                }));
            }
        }
    }
    /* function is used to load pdf */
    /**
     * @return {?}
     */
    renderPdf() {
        PDFJS.workerSrc = 'assets/JS/pdf.worker.js';
        PDFJS.getDocument(this.PDFRenderOption.documentId).then((/**
         * @param {?} pdf
         * @return {?}
         */
        pdf => {
            this.PDFRenderOption.pdfDocument = pdf;
            this.PDFInfo.totalPages = this.PDFRenderOption.pdfDocument.pdfInfo.numPages;
            this.config.totalpages = this.PDFInfo.totalPages;
            /** @type {?} */
            let viewer = document.getElementById('viewer' + this.config.viewerId);
            viewer.innerHTML = '';
            for (let i = 0; i < this.PDFInfo.totalPages; i++) {
                /** @type {?} */
                let page = UI.createPage(i + 1);
                viewer.appendChild(page);
            }
            if (this.PDFInfo.currentPage === undefined)
                this.PDFInfo.currentPage = 1;
            this.renderView(false, this.PDFInfo.currentPage);
            UI.disableEdit();
        }), (/**
         * @param {?} error
         * @return {?}
         */
        error => {
            console.log('Error', error);
            /** @type {?} */
            var loadinghtml = document.getElementById('loadingError');
            if (loadinghtml)
                document.getElementById('loadingError').innerHTML = "Document(s) for case id  <b>" + this.documentId + " </b> is not found. To resolve this issue, contact your system administrator.";
            this.annotationPDFError.emit("error");
        }));
    }
    /* function is used to render the page in UI */
    /**
     * @param {?} isZoomchanged
     * @param {?} pageNumber
     * @return {?}
     */
    renderView(isZoomchanged, pageNumber) {
        UI.renderPage(pageNumber, this.PDFRenderOption).then((/**
         * @param {?} __0
         * @return {?}
         */
        ([pdfPage, annotations]) => {
            if (this.isFirstLoad || isZoomchanged) {
                /** @type {?} */
                let canvasWidth = document.getElementById(this.config.viewerId);
                if (this.isFirstLoad) {
                    this.PDFRenderOption.scale = parseFloat((canvasWidth.offsetWidth / pdfPage.view[2]).toFixed(2));
                    this.config.zoomLevel = this.PDFRenderOption.scale;
                    this.isFirstLoad = false;
                    return;
                }
                this.renderPdf();
                return;
            }
            /** @type {?} */
            let viewport = pdfPage.getViewport(this.PDFRenderOption.scale, this.PDFRenderOption.rotate);
            this.PAGE_HEIGHT = viewport.height;
        }));
        if (this.config.loadallpages === true) { // load all pages at time
            UI.renderPage(2, this.PDFRenderOption).then((/**
             * @param {?} __0
             * @return {?}
             */
            ([pdfPage, annotations]) => {
                /** @type {?} */
                let viewport = pdfPage.getViewport(this.PDFRenderOption.scale, this.PDFRenderOption.rotate);
                this.PAGE_HEIGHT = viewport.height;
                this.renderallpages(3);
            }));
        }
        this.showLoading = false;
        this.isPdfLoaded.emit(true);
    }
    /**
     * @param {?} pagenumber
     * @return {?}
     */
    renderallpages(pagenumber) {
        UI.renderPage(pagenumber, this.PDFRenderOption).then((/**
         * @param {?} __0
         * @return {?}
         */
        ([pdfPage, annotations]) => {
            if (pdfPage.pageNumber != this.PDFInfo.totalPages) {
                this.renderallpages(pdfPage.pageNumber + 1);
            }
        }));
    }
    /* function is used to get index of annotation from right side data object */
    /**
     * @param {?} tmpId
     * @return {?}
     */
    getAnnotationIndex(tmpId) {
        /** @type {?} */
        let anno_index = this.findAnnotation(this.documentId, tmpId);
        return anno_index.toString();
    }
    /* function is used to load initial annotations */
    /**
     * @param {?} documentId
     * @return {?}
     */
    getAnnotations(documentId) {
        return this.PDFannotations || [];
    }
    /**
     * @param {?} documentId
     * @param {?} annotationId
     * @return {?}
     */
    findAnnotation(documentId, annotationId) {
        /** @type {?} */
        let index = -1;
        /** @type {?} */
        let annotations = this.getAnnotations(documentId);
        for (let i = 0, l = annotations.length; i < l; i++) {
            if (annotations[i].uuid === annotationId) {
                index = i;
                break;
            }
        }
        return index;
    }
    /**
     * @param {?} documentId
     * @param {?} annotations
     * @return {?}
     */
    updateAnnotations(documentId, annotations) {
        this.PDFannotations = annotations;
    }
    /* function is used to load dynamic URL's */
    /**
     * @param {?} url
     * @return {?}
     */
    loadScript(url) {
        /** @type {?} */
        let node = document.createElement('script');
        node.src = url;
        node.type = 'text/javascript';
        node.async = true;
        node.charset = 'utf-8';
        document.getElementsByTagName('head')[0].appendChild(node);
    }
    /**
     * @param {?} pageNumber
     * @param {?=} zoomChanged
     * @return {?}
     */
    renderPage(pageNumber, zoomChanged) {
        UI.renderPage(pageNumber, this.PDFRenderOption).then((/**
         * @param {?} __0
         * @return {?}
         */
        ([pdfPage, annotations]) => {
            /** @type {?} */
            let viewport = pdfPage.getViewport(this.PDFRenderOption.scale, this.PDFRenderOption.rotate);
            this.PAGE_HEIGHT = viewport.height;
            // if(zoomChanged)
            // this.isPdfLoaded.emit({"isLoaded":true,"pageSize":this.PAGE_HEIGHT+"-"+ viewport.width,"pageNumber":pageNumber});
            if (zoomChanged) {
                /** @type {?} */
                var parentElement = document.getElementById(this.config.viewerId);
                /** @type {?} */
                var firstPage = (/** @type {?} */ (parentElement.querySelector("[id=pageContainer" + ((pageNumber)) + "]")));
                //parentElement[0].getElementById("pageContainer" + ((pageNumber)));
                /** @type {?} */
                var height = firstPage.style.height;
                /** @type {?} */
                var width = firstPage.style.width;
                /** @type {?} */
                var allClasses = parentElement.querySelectorAll("[class=page]");
                // let allClasses = parentElement[0].getElementsByClassName("page");
                for (var i = 0; i < allClasses.length; i++) {
                    allClasses[i]["style"]["height"] = height;
                    allClasses[i]["style"]["width"] = width;
                }
                setTimeout((/**
                 * @return {?}
                 */
                () => {
                    document.getElementById(this.config.viewerId).scrollTop =
                        ((pageNumber - 1) * this.PAGE_HEIGHT) + 30;
                    this.showBeforePreviousPagesonScroll(pageNumber);
                }), 0);
            }
            // handle teserract code for page
            this.teseRactInitforPage(pdfPage, pageNumber);
        }));
    }
    /**
     * @param {?} pdfPage
     * @param {?} pageNumber
     * @return {?}
     */
    teseRactInitforPage(pdfPage, pageNumber) {
        if (this.config.useteseract && !this.pageTmpCanvasLoaded[pageNumber]) {
            /** @type {?} */
            var canvasavail = document.getElementById("tmpcanvas" + this.config.viewerId + pageNumber);
            if (canvasavail == undefined) {
                /** @type {?} */
                var canvas = (/** @type {?} */ (document.createElement('canvas')));
                canvas.id = "tmpcanvas" + this.config.viewerId + pageNumber;
                canvas.style.display = "none";
                /** @type {?} */
                var body = document.getElementById(this.config.viewerId);
                body.appendChild(canvas);
            }
            if (this.pageTmpCanvasLoaded[pageNumber] == undefined) {
                /* teserract code  start */
                /** @type {?} */
                var scale = 3;
                /** @type {?} */
                var viewporttmpcanvas = pdfPage.getViewport(scale);
                /** @type {?} */
                var canvas = (/** @type {?} */ (document.getElementById("tmpcanvas" + this.config.viewerId + pageNumber)));
                canvas.height = viewporttmpcanvas.height;
                canvas.width = viewporttmpcanvas.width;
                /** @type {?} */
                var context = canvas.getContext('2d');
                /** @type {?} */
                var renderContext = {
                    canvasContext: context,
                    viewport: viewporttmpcanvas
                };
                pdfPage.render(renderContext);
                this.pageTmpCanvasLoaded[pageNumber] = true;
                /* teserract code  end */
            }
        }
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        /** @type {?} */
        const docId = changes.documentId;
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    configChanged(changes) {
        if (changes["_changesHead"] && changes["_changesHead"]["key"] == "zoomLevel") {
            this.PDFRenderOption.scale = changes["_changesHead"]["currentValue"];
            /** @type {?} */
            let viewer = document.getElementById('viewer' + this.config.viewerId);
            viewer.innerHTML = '';
            for (let i = 0; i < this.PDFInfo.totalPages; i++) {
                /** @type {?} */
                let page = UI.createPage(i + 1);
                viewer.appendChild(page);
            }
            this.pageLoaded = {};
            this.pageLoaded[this.PDFInfo.currentPage] = true;
            /** @type {?} */
            let loadedPageskeys = Object.keys(this.pageLoaded);
            for (let i = 0; i < loadedPageskeys.length; i++) {
                /** @type {?} */
                let pageNumber = parseInt(loadedPageskeys[i]);
                this.renderPage(pageNumber, true);
            }
            this.scrollFromJS = true;
        }
    }
    /**
     * @return {?}
     */
    ngDoCheck() {
        /** @type {?} */
        const changes = this.configDiffer.diff(this.config);
        if (changes) {
            this.configChanged(changes);
        }
    }
    /* function use for scroll to the particular rect position */
    /**
     * @param {?} annotation
     * @return {?}
     */
    setScroll(annotation) {
        if (annotation == undefined)
            return;
        /** @type {?} */
        let scalerender = this.PDFRenderOption.scale * 100;
        /** @type {?} */
        let scaleheight = (scalerender * annotation.y) / 100;
        /** @type {?} */
        let scalewidth = (scalerender * annotation.x) / 100;
        this.PDFInfo.currentPage = annotation.page;
        /** @type {?} */
        let visiblePage = document.getElementById(this.config.viewerId).querySelector(`.page[data-page-number="${this.PDFInfo.currentPage}"][data-loaded="false"]`);
        if (visiblePage) {
            UI.renderPage(this.PDFInfo.currentPage, this.PDFRenderOption).then((/**
             * @param {?} __0
             * @return {?}
             */
            ([pdfPage, annotations]) => {
                setTimeout((/**
                 * @return {?}
                 */
                () => {
                    document.getElementById(this.config.viewerId).scrollTop =
                        (parseInt(annotation.page) - 1) * this.PAGE_HEIGHT + scaleheight - 20;
                    document.getElementById(this.config.viewerId).scrollLeft = scalewidth + 5;
                    this.showBeforePreviousPagesonScroll(this.PDFInfo.currentPage); // to load previous,next pages when viewing particular page
                    // to load previous,next pages when viewing particular page
                    /** @type {?} */
                    var allrect = Array.from(document.getElementById(this.config.viewerId).querySelectorAll("rect[data-pdf-annotate-id='" + annotation.uuid + "']"));
                    allrect.forEach((/**
                     * @param {?} rect
                     * @return {?}
                     */
                    function (rect) {
                        rect.classList.add('active');
                    }));
                }), 0);
                if (this.config.useteseract) {
                    this.teseRactInitforPage(pdfPage, this.PDFInfo.currentPage);
                }
            }));
        }
        else {
            if (this.config.useteseract) {
                this.renderPDFForeTeserract(annotation);
            }
            document.getElementById(this.config.viewerId).scrollTop =
                (parseInt(annotation.page) - 1) * this.PAGE_HEIGHT + scaleheight - 20;
            document.getElementById(this.config.viewerId).scrollLeft = scalewidth + 5;
            /** @type {?} */
            var allrect = Array.from(document.getElementById(this.config.viewerId).querySelectorAll("rect[data-pdf-annotate-id='" + annotation.uuid + "']"));
            allrect.forEach((/**
             * @param {?} rect
             * @return {?}
             */
            function (rect) {
                rect.classList.add('active');
            }));
        }
    }
    /**
     * @param {?} annotation
     * @return {?}
     */
    renderPDFForeTeserract(annotation) {
        if (this.config.useteseract && !this.pageTmpCanvasLoaded[annotation.page]) {
            UI.renderPage(annotation.page, this.PDFRenderOption).then((/**
             * @param {?} __0
             * @return {?}
             */
            ([pdfPage, annotations]) => {
                /* teserract code  start */
                /** @type {?} */
                var scale = 3;
                /** @type {?} */
                var viewporttmpcanvas = pdfPage.getViewport(scale);
                /** @type {?} */
                var canvas = (/** @type {?} */ (document.getElementById("tmpcanvas" + this.config.viewerId + annotation.page)));
                if (canvas === null) {
                    this.teseRactInitforPage(pdfPage, annotation.page);
                }
                else {
                    canvas.height = viewporttmpcanvas.height;
                    canvas.width = viewporttmpcanvas.width;
                    /** @type {?} */
                    var context = canvas.getContext('2d');
                    /** @type {?} */
                    var renderContext = {
                        canvasContext: context,
                        viewport: viewporttmpcanvas
                    };
                    pdfPage.render(renderContext);
                }
                /* teserract code  end */
            }));
        }
    }
    /* reset the active rect */
    /**
     * @return {?}
     */
    resetActiveRectClass() {
        /** @type {?} */
        var allrect = Array.from(document.getElementById(this.config.viewerId).querySelectorAll("rect[class='active']"));
        allrect.forEach((/**
         * @param {?} rect
         * @return {?}
         */
        function (rect) {
            rect.classList.remove('active');
        }));
    }
    /**
     * @param {?} uuid
     * @return {?}
     */
    highlightAnnotationEvent(uuid) {
        if (this.config.deleteAlert) {
            if (this._elementRef.nativeElement.querySelector("#annotate-delete-overlay-done")) {
                document.getElementById("annotate-delete-overlay-done").classList.add("disableDelete");
            }
        }
        /** @type {?} */
        let annotationIndex = this.findAnnotation(this.documentId, uuid);
        this.resetActiveRectClass();
        this.setScroll(this.PDFannotations[annotationIndex]);
    }
    /**
     * @param {?} uuid
     * @return {?}
     */
    editAnnotationEvent(uuid) {
        /** @type {?} */
        let annotationIndex = this.findAnnotation(this.documentId, uuid);
        if (annotationIndex == -1)
            return;
        if (this.config.history_enabled) {
            this.addannotationtoHistory(this.PDFannotations[annotationIndex]);
        }
        this.resetActiveRectClass();
        if (this.config.history_enabled) {
            this.editHistoryLength = (this.annotationHistory && this.annotationHistory[uuid]) ? this.annotationHistory[uuid].length : '0';
        }
        this.setScroll(this.PDFannotations[annotationIndex]);
        /** @type {?} */
        var target = Array.from(document.getElementById(this.config.viewerId).querySelectorAll("rect[data-pdf-annotate-id='" + uuid + "']"));
        /* enable annotation id to edit */
        target.forEach((/**
         * @param {?} rect
         * @return {?}
         */
        function (rect) {
            if (rect["style"]["display"] == "none") {
                rect["style"]["display"] = "block";
            }
        }));
        setTimeout((/**
         * @return {?}
         */
        () => {
            UI.enableEdit();
            this.editannotationuuid = uuid;
            this.editAnnotation(uuid);
        }), 200);
    }
    /**
     * @param {?} uuid
     * @return {?}
     */
    addAnnotationEvent(uuid) {
        this.eventName = "AddEvent";
        this.newannotationuuid = uuid;
        UI.disableEdit();
        document.getElementById(this.config.viewerId).classList.add("cropping");
        UI.enableRect("area");
        this.rectHideandShow('transparent');
    }
    /* function use for edit annotation */
    /**
     * @param {?} uuid
     * @return {?}
     */
    editAnnotation(uuid) {
        document.getElementById(this.config.viewerId).classList.remove('cropping');
        UI.disableRect();
        /** @type {?} */
        var target = Array.from(document.getElementById(this.config.viewerId).querySelectorAll("rect[data-pdf-annotate-id='" + uuid + "']"));
        /* enable annotation id to edit */
        target.forEach((/**
         * @param {?} rect
         * @return {?}
         */
        function (rect) {
            if (rect["style"]["display"] === "none") {
                rect["style"]["display"] = "block";
            }
        }));
        UI.fireEvent('annotation:click', target[0]);
        setTimeout((/**
         * @return {?}
         */
        () => {
            this.rectHideandShow('transparent');
        }), 400);
    }
    /* event fire when click on annotation */
    /**
     * @param {?} target
     * @return {?}
     */
    handleAnnotationClick(target) {
        if (this.config.deleteAlert && (this._elementRef.nativeElement.querySelector("#annotate-delete-overlay-done"))) {
            document.getElementById("annotate-delete-overlay-done").classList.add("activeDelete");
            document.getElementById("annotate-delete-overlay-done").classList.remove("disableDelete");
        }
        setTimeout((/**
         * @return {?}
         */
        () => {
            if (this._elementRef.nativeElement.querySelector("#pdf-annotate-edit-overlay")) {
                this._renderer.appendChild(this._elementRef.nativeElement.querySelector("#pdf-annotate-edit-overlay"), this.child_div);
            }
            if (this.config.history_enabled) {
                setTimeout((/**
                 * @return {?}
                 */
                () => {
                    if (this._elementRef.nativeElement.querySelector("#undo_span_id"))
                        this._elementRef.nativeElement.querySelector("#undo_span_id").innerText = "Undo (" + (this.editHistoryLength === "1" ? "0" : (parseInt(this.editHistoryLength) - 1).toString()) + ")";
                }), 500);
            }
        }), 500);
    }
    /* used the below funtion to hide rect when adding new annotation */
    /**
     * @param {?} colortype
     * @return {?}
     */
    rectHideandShow(colortype) {
        /** @type {?} */
        var allrect = Array.from(document.getElementById(this.config.viewerId).querySelectorAll("rect"));
        allrect.forEach((/**
         * @param {?} rect
         * @return {?}
         */
        function (rect) {
            if (rect.getAttribute("data-pdf-annotate-id") != this.editannotationuuid) {
                if (colortype == "transparent") {
                    rect.style.display = "none";
                }
                else {
                    rect.style.display = "block";
                }
            }
        }).bind(this));
    }
    /**
     * @param {?} annotation
     * @return {?}
     */
    addannotationtoHistory(annotation) {
        /** @type {?} */
        var anno = {};
        /** @type {?} */
        var target = Array.from(document.getElementById(this.config.viewerId).querySelectorAll("rect[data-pdf-annotate-id='" + annotation.uuid + "']"));
        Object.assign(anno, annotation);
        if (this.annotationHistory[annotation.uuid]) {
            /** @type {?} */
            var is_there_annotation = false;
            for (var i = 0; i < this.annotationHistory[annotation.uuid].length; i++) {
                if (JSON.stringify(this.annotationHistory[annotation.uuid][i].annotation) === JSON.stringify(annotation)) {
                    is_there_annotation = true;
                    break;
                }
            }
            if (is_there_annotation == false && this.annotationHistory[annotation.uuid].length < this.config.history_count_per_annotation)
                this.annotationHistory[annotation.uuid].push({ "annotation": anno, "target": target[0] });
        }
        else {
            this.annotationHistory[annotation.uuid] = [];
            this.annotationHistory[annotation.uuid].push({ "annotation": anno, "target": target[0] });
        }
    }
    /**
     * @return {?}
     */
    handleUndo() {
        this.eventName = "undoEvent";
        /** @type {?} */
        let alength = this.annotationHistory[this.editannotationuuid].length - 2;
        if (alength < 0)
            return;
        /** @type {?} */
        let old_annotation = this.annotationHistory[this.editannotationuuid][alength].annotation;
        /** @type {?} */
        let old_target = this.annotationHistory[this.editannotationuuid][alength].target;
        /** @type {?} */
        let rect = Array.from(document.getElementById(this.config.viewerId).querySelectorAll("rect[data-pdf-annotate-id='" + old_annotation.uuid + "']"))[0];
        rect.setAttribute("x", old_target.getAttribute("x"));
        rect.setAttribute("y", old_target.getAttribute("y"));
        rect.setAttribute("width", old_target.getAttribute("width"));
        rect.setAttribute("height", old_target.getAttribute("height"));
        this.eventName = "";
        PDFJSAnnotate.__storeAdapter.editAnnotation(this.documentId, this.annotationHistory[this.editannotationuuid][alength].annotation.uuid, this.annotationHistory[this.editannotationuuid][alength].annotation);
        /** @type {?} */
        var p = this.annotationHistory[this.editannotationuuid];
        this.annotationHistory[this.editannotationuuid] = [];
        if (p.length == 2) {
            Object.assign(p, []);
        }
        else {
            /** @type {?} */
            let s = p.splice(this.annotationHistory[this.editannotationuuid].length - 1, 1);
            this.annotationHistory[this.editannotationuuid] = p;
        }
    }
    /**
     * @param {?} statusFilter
     * @return {?}
     */
    filterAnnotationsbyStatus(statusFilter) {
        if (statusFilter.length == 0) {
            this.rectHideandShow("color");
            return;
        }
        /** @type {?} */
        let queryFilterString = "";
        /** @type {?} */
        let queryFilterString_hidden = "";
        setTimeout((/**
         * @return {?}
         */
        () => {
            /* matched nodes showing */
            statusFilter.forEach((/**
             * @param {?} element
             * @return {?}
             */
            element => {
                queryFilterString = queryFilterString + "rect[status='" + element + "'],";
            }));
            queryFilterString = queryFilterString.substr(0, queryFilterString.length - 1);
            /** @type {?} */
            let filter_nodes = Array.from(document.getElementById(this.config.viewerId).querySelector('.page[data-page-number="' + this.PDFInfo.currentPage + '"]').querySelectorAll(queryFilterString));
            filter_nodes.forEach((/**
             * @param {?} rect
             * @return {?}
             */
            function (rect) {
                rect["style"]["display"] = "block";
            }));
            /* unmatched nodes hidden */
            statusFilter.forEach((/**
             * @param {?} element
             * @return {?}
             */
            element => {
                queryFilterString_hidden = queryFilterString_hidden + "rect:not([status='" + element + "']),";
            }));
            queryFilterString_hidden = queryFilterString_hidden.substr(0, queryFilterString_hidden.length - 1);
            /** @type {?} */
            let filter_nodes_hidden = Array.from(document.getElementById(this.config.viewerId).querySelector('.page[data-page-number="' + this.PDFInfo.currentPage + '"]').querySelectorAll(queryFilterString_hidden));
            filter_nodes_hidden.forEach((/**
             * @param {?} rect
             * @return {?}
             */
            function (rect) {
                rect["style"]["display"] = "none";
            }));
        }), 0);
    }
}
CustomannotationComponent.decorators = [
    { type: Component, args: [{
                selector: 'lk-annotation',
                template: "<div *ngIf=\"config\">\n    <div [id]=\"config.viewerId\" class=\"pdf-viewer\" style=\"width:100%\" (scroll)=\"pdfScroll($event)\">\n        <div *ngIf=\"showLoading\" class=\"\" style=\"margin: 0 auto; text-align: center;margin-top:10%; text-align: center\">\n            <i class=\"fa fa-spinner fa-spin\"></i><span id=\"loadingError\"> {{loadingMsg}}</span>\n        </div>\n        <div id=\"content-wrapper\">\n            <div [id]=\"'viewer'+config.viewerId\" class=\"pdfViewer\"></div>\n        </div>\n    </div>\n    <canvas *ngIf=\"config.useteseract\" [id]=\"'tmpcanvas' + config.viewerId\" width=\"1218\" height=\"1582\"\n        style=\"width: 1218px; height: 1582px;display:none;\"></canvas>\n</div>",
                encapsulation: ViewEncapsulation.None,
                styles: [".my-name{color:red}#pdf-annotate-edit-overlay{background-color:transparent!important;z-index:100000}#pdf-annotate-edit-overlay-done{bottom:-10px;position:absolute}#pdf-annotate-edit-overlay-done .popover{position:inherit;width:150px;height:50px;background-color:#fff;border-radius:4px;top:10px;left:0;box-shadow:3px -2px 4px #aaa}#pdf-annotate-edit-overlay-done .popover-arrow{position:absolute;top:-10px;left:20px;border-left:10px solid transparent;border-right:10px solid transparent;border-bottom:10px solid #f8f7f7;width:0;height:0;-webkit-filter:drop-shadow(0 -2px 2px #aaa)}#pdf-annotate-edit-overlay-done .fa-check-circle{font-size:20px;margin:10px 5px 5px -20px!important}#pdf-annotate-edit-overlay-done .fa-check-circle span{font-size:14px;font-family:monospace;display:inline-block;vertical-align:middle;padding:4px;width:140px}#pdf-annotate-edit-overlay-done .fa-undo{font-size:16px;margin:0 5px 7px -17px!important}#pdf-annotate-edit-overlay-done .fa-undo span{font-size:14px;font-family:monospace;display:inline-block;vertical-align:middle;padding:4px;width:140px}.rect-mouse-down{cursor:col-resize!important}.pdf-viewer-container{background-color:#fff}.pdf-viewer-container .cropping{cursor:se-resize!important}.pdf-viewer-container .cropping .annotationLayer{background-color:rgba(0,0,0,.3)!important}.pdf-viewer-container .selecting{cursor:hand!important}.pdf-viewer-container .selecting .annotationLayer{background-color:rgba(0,0,0,.3)!important}.pdf-viewer-container .no-padding-no-margin{padding:0!important;margin:0!important}.pdf-viewer-container .pdf-viewer-tools{background-color:grey;padding:4px;margin:8px}.pdf-viewer-container .pdf-viewer-tools .zoom-disabled{cursor:not-allowed;color:#d3d3d3}.pdf-viewer-container .pdf-viewer-tools .page-count{border-right:1px solid;display:inline-block}.pdf-viewer-container .pdf-viewer-tools .page-count span{padding-right:4px}.pdf-viewer-container .pdf-viewer-tools .page-zoom{display:inline-block}.pdf-viewer-container .pdf-viewer-tools .page-zoom .icon-padding{padding:6px 10px 6px 6px;cursor:pointer}.pdf-viewer-container .pdf-viewer{height:calc(100vh - 130px);overflow-y:auto;overflow-x:hidden}.pdf-viewer-container .pdf-viewer .textLayer{position:absolute;left:0;top:0;right:0;bottom:0;overflow:hidden;opacity:.2;line-height:1;z-index:99998}.pdf-viewer-container .pdf-viewer .textLayer>div{color:transparent;position:absolute;white-space:pre;cursor:text;transform-origin:0 0}.pdf-viewer-container .pdf-viewer .textLayer .highlight{margin:-1px;padding:1px;background-color:#b400aa;border-radius:4px}.pdf-viewer-container .pdf-viewer .textLayer .highlight.begin{border-radius:4px 0 0 4px}.pdf-viewer-container .pdf-viewer .textLayer .highlight.end{border-radius:0 4px 4px 0}.pdf-viewer-container .pdf-viewer .textLayer .highlight.middle{border-radius:0}.pdf-viewer-container .pdf-viewer .textLayer .highlight.selected{background-color:#006400}.pdf-viewer-container .pdf-viewer .textLayer ::selection{background:#00f}.pdf-viewer-container .pdf-viewer .textLayer ::-moz-selection{background:#00f}.pdf-viewer-container .pdf-viewer .textLayer .endOfContent{display:block;position:absolute;left:0;top:100%;right:0;bottom:0;z-index:-1;cursor:default;-webkit-user-select:none;-ms-user-select:none;-moz-user-select:none}.pdf-viewer-container .pdf-viewer .textLayer .endOfContent.active{top:0}.pdf-viewer-container .pdf-viewer .annotationLayer{position:absolute;top:0;left:0;right:0;bottom:0;z-index:99999}.pdf-viewer-container .pdf-viewer .annotationLayer rect{stroke-dasharray:2;stroke:#00a3e0;fill:rgba(0,163,224,.08);pointer-events:all}.pdf-viewer-container .pdf-viewer .annotationLayer rect:hover{fill:rgba(237,139,0,.08);stroke:#ed8b00}.pdf-viewer-container .pdf-viewer .annotationLayer rect:hover+circle{fill:#ed8b00;stroke:#ed8b00}.pdf-viewer-container .pdf-viewer .annotationLayer rect.active{fill:rgba(237,139,0,.08);stroke:#ed8b00;stroke-dasharray:10}.pdf-viewer-container .pdf-viewer .annotationLayer rect.active+circle{fill:#ed8b00!important;stroke:#ed8b00!important}.pdf-viewer-container .pdf-viewer .annotationLayer circle{fill:#00a3e0!important;pointer-events:all;stroke:transparent!important}.pdf-viewer-container .pdf-viewer .annotationLayer text{font-size:12px;fill:#fff!important}.pdf-viewer-container .pdf-viewer .annotationLayer section{position:absolute}.pdf-viewer-container .pdf-viewer .annotationLayer .linkAnnotation>a{position:absolute;font-size:1em;top:0;left:0;width:100%;height:100%;background:url(data:image/gif;base64,R0lGODlhAQABAIAAAAAAAP///yH5BAEAAAAALAAAAAABAAEAAAIBRAA7)}.pdf-viewer-container .pdf-viewer .annotationLayer .linkAnnotation>a:hover{opacity:.2;background:#ff0;box-shadow:0 2px 10px #ff0}.pdf-viewer-container .pdf-viewer .annotationLayer .textAnnotation img{position:absolute;cursor:pointer}.pdf-viewer-container .pdf-viewer .annotationLayer .popupWrapper{position:absolute;width:20em}.pdf-viewer-container .pdf-viewer .annotationLayer .popup{position:absolute;z-index:200;max-width:20em;background-color:#ff9;box-shadow:0 2px 5px #333;border-radius:2px;padding:.6em;margin-left:5px;cursor:pointer;word-wrap:break-word}.pdf-viewer-container .pdf-viewer .annotationLayer .popup h1{font-size:1em;border-bottom:1px solid #000;padding-bottom:.2em}.pdf-viewer-container .pdf-viewer .annotationLayer .popup p{padding-top:.2em}.pdf-viewer-container .pdf-viewer .annotationLayer .fileAttachmentAnnotation,.pdf-viewer-container .pdf-viewer .annotationLayer .highlightAnnotation,.pdf-viewer-container .pdf-viewer .annotationLayer .squigglyAnnotation,.pdf-viewer-container .pdf-viewer .annotationLayer .strikeoutAnnotation,.pdf-viewer-container .pdf-viewer .annotationLayer .underlineAnnotation{cursor:pointer}.pdf-viewer-container .pdf-viewer .pdfViewer .canvasWrapper{overflow:hidden}.pdf-viewer-container .pdf-viewer .pdfViewer .page{direction:ltr;width:816px;height:1056px;margin:1px auto 0;position:relative;overflow:visible;background-clip:content-box;background-color:#fff}.pdf-viewer-container .pdf-viewer .pdfViewer.removePageBorders .page{margin:0 auto 10px;border:none}.pdf-viewer-container .pdf-viewer .pdfViewer .page canvas{margin:0;display:block}.pdf-viewer-container .pdf-viewer .pdfViewer .page .loadingIcon{position:absolute;display:block;left:0;top:0;right:0;bottom:0}.pdf-viewer-container .pdf-viewer .pdfPresentationMode:-webkit-full-screen .pdfViewer .page{margin-bottom:100%;border:0}.pdf-viewer-container .pdf-viewer .pdfPresentationMode:-ms-fullscreen .pdfViewer .page{margin-bottom:100%!important;border:0}.pdf-viewer-container .pdf-viewer .pdfPresentationMode:fullscreen .pdfViewer .page{margin-bottom:100%;border:0}.review-table-container{max-height:calc(100vh - 150px);overflow-y:auto;width:100%}.review-table-container .disabled{color:grey!important}.review-table-container .table-border{border:1px solid #d0d0ce}.review-table-container .btn-group,.review-table-container .btn-group-vertical{top:-8px!important;padding-right:6px!important}.review-table-container tbody tr{height:35px!important}.review-table-container tbody tr:hover{background-color:#eee}.review-table-container tbody td{padding:.1em!important;vertical-align:middle!important;text-align:center}.review-table-container tbody td .fa{display:inline!important}.review-table-container tbody td .reject-dropdown{padding:1px!important}.review-table-container tbody td .reject-dropdown li{padding:0;font-size:14px}.review-table-container tbody td .reject-dropdown li .dropdown-item{white-space:normal!important;padding:4px 10px!important}.review-table-container tbody td .dropdown-menu{z-index:9999;background-color:#fff}.review-table-container tbody td .custom-reject-reason-container{padding:5px}.review-table-container tbody td .custom-reject-reason-container .reject-reason-area{width:100%;background:0 0!important;border:none!important;font-size:12px}.review-table-container tbody td .custom-reject-reason-container .reason-area{width:90%;display:inline-block}.review-table-container tbody td .custom-reject-reason-container .reason-action-area{width:10%;display:inline-block;cursor:pointer}.review-table-container tbody td .custom-reject-reason-container .reject-dwn-btn{width:100%;font-size:13px;text-align:left}.review-table-container tbody td .custom-reject-reason-container .togglegrpbtn{width:100%;top:0!important;font-size:13px}.review-table-container tbody td .custom-reject-reason-container .togglebtn{background-color:#fff;width:100%}.review-table-container tbody .reject-row{border:none!important}.review-table-container tbody .reject-row .reject-row-area{margin:0 30px;text-align:left;float:left;font-size:14px}.review-table-container .table-header{font-family:Roboto;font-size:14px;font-weight:500;font-style:normal;font-stretch:normal;letter-spacing:normal;color:#9b9b9b;text-align:center}"]
            }] }
];
/** @nocollapse */
CustomannotationComponent.ctorParameters = () => [
    { type: KeyValueDiffers },
    { type: ElementRef },
    { type: Renderer2 }
];
CustomannotationComponent.propDecorators = {
    pageChanged: [{ type: Output }],
    annotationEdited: [{ type: Output }],
    annotationAdded: [{ type: Output }],
    annotationDeleted: [{ type: Output }],
    captureData: [{ type: Output }],
    mouseLeaveFrmPDF: [{ type: Output }],
    annotationPDFError: [{ type: Output }],
    isPdfLoaded: [{ type: Output }],
    PDFannotations: [{ type: Input }],
    documentId: [{ type: Input }],
    config: [{ type: Input }],
    pdfScroll: [{ type: HostListener, args: ['window:scroll', ['$event'],] }]
};

/**
 * @fileoverview added by tsickle
 * Generated from: lib/customannotation.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class CustomannotationModule {
}
CustomannotationModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    FormsModule
                ],
                declarations: [CustomannotationComponent],
                exports: [CustomannotationComponent]
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: public_api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: customannotation.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { CustomannotationService, CustomannotationComponent, CustomannotationModule };

//# sourceMappingURL=customannotation.js.map