import { OnInit, OnChanges, EventEmitter, KeyValueChanges, KeyValueDiffers, SimpleChanges, ElementRef, Renderer2 } from '@angular/core';
export interface Filters {
    "filter": string;
}
export interface PDFconfig {
    "rendercirclesalongwithindex"?: boolean;
    "loadallpages": boolean;
    "zoomLevel"?: any;
    "rotate"?: any;
    "totalpages": number;
    "history_enabled"?: boolean;
    "history_count_per_annotation"?: number;
    "statusFilter"?: Array<Filters>;
    "deleteAlert"?: boolean;
    "useteseract"?: boolean;
    "viewerId"?: string;
}
export declare class CustomannotationComponent implements OnInit, OnChanges {
    private differs;
    private _elementRef;
    private _renderer;
    pageChanged: EventEmitter<{}>;
    annotationEdited: EventEmitter<{}>;
    annotationAdded: EventEmitter<{}>;
    annotationDeleted: EventEmitter<{}>;
    captureData?: EventEmitter<{}>;
    mouseLeaveFrmPDF: EventEmitter<{}>;
    annotationPDFError: EventEmitter<{}>;
    isPdfLoaded: EventEmitter<{}>;
    PDFannotations: any;
    documentId: string;
    config: PDFconfig;
    loadingMsg: any;
    private configDiffer;
    showLoading: boolean;
    isFirstLoad: boolean;
    renderCircleObj: any;
    PDFRenderOption: {
        documentId: string;
        pdfDocument: any;
        scale: number;
        rotate: number;
    };
    PDFInfo: {
        totalPages: number;
        currentPage: number;
    };
    PAGE_HEIGHT: number;
    pageLoaded: any;
    pageTmpCanvasLoaded: any;
    child_div: any;
    annotationHistory: any;
    newannotationuuid: string;
    editannotationuuid: string;
    editHistoryLength: string;
    eventName: string;
    img: any;
    scrollFromJS: boolean;
    constructor(differs: KeyValueDiffers, _elementRef: ElementRef, _renderer: Renderer2);
    ngOnInit(): void;
    handleSaveEdit: () => void;
    handleDeleteAlert: () => void;
    pdfScroll(event: any): void;
    showBeforePreviousPagesonScroll(pageNumber: any): void;
    renderPdf(): void;
    renderView(isZoomchanged: any, pageNumber: any): void;
    renderallpages(pagenumber: any): void;
    getAnnotationIndex(tmpId: any): string;
    getAnnotations(documentId: any): any;
    findAnnotation(documentId: any, annotationId: any): number;
    updateAnnotations(documentId: any, annotations: any): void;
    loadScript(url: any): void;
    renderPage(pageNumber: number, zoomChanged?: any): void;
    teseRactInitforPage(pdfPage: any, pageNumber: any): void;
    ngOnChanges(changes: SimpleChanges): void;
    configChanged(changes: KeyValueChanges<string, any>): void;
    ngDoCheck(): void;
    setScroll(annotation: any): void;
    renderPDFForeTeserract(annotation: any): void;
    resetActiveRectClass(): void;
    highlightAnnotationEvent(uuid: string): void;
    editAnnotationEvent(uuid: string): void;
    addAnnotationEvent(uuid: string): void;
    editAnnotation(uuid: string): void;
    handleAnnotationClick(target: any): void;
    rectHideandShow(colortype: any): void;
    addannotationtoHistory(annotation: any): void;
    handleUndo(): void;
    filterAnnotationsbyStatus(statusFilter: Array<Filters>): void;
}
